
/**************************************************************************
 *
 *  $Id: mbg_qnx.h 1.1 2001/03/05 16:37:55 MARTIN REL_M $
 *
 *  Copyright (c) Meinberg Funkuhren, Bad Pyrmont, Germany
 *
 *  Description:
 *    OS dependent definitions/redefinitions for QNX
 *
 *  This is a very early version of this file. Please report any
 *  comments or required modifications to
 *  Martin Burnicki <martin.burnicki@meinberg.de>
 *
 * -----------------------------------------------------------------------
 *  $Log: mbg_qnx.h $
 *  Revision 1.1  2001/03/05 16:37:55  MARTIN
 *  Initial revision
 *  Revision 1.1  2001/03/15 11:27:23  MARTIN
 *
 **************************************************************************/

#ifndef _MBG_QNX_H
#define _MBG_QNX_H


/* Other headers to be included */


// According tothe Neutrino beta docs the following symbols
// are predefined to account for the development environment:

#if defined( __WATCOMC__ )
  /* The program is compiled using Watcom C */
#elif defined( __GNUC__ )
  /* The program is compiled using GNU C */
#elif defined( __MWERKS__ )
  /* The program is compiled using Metroworks */
#endif

#if defined( __QNXNTO__ )
  /* The program is compiled for QNX Neutrino */
#else
  /* The program is compiled for QNX 4 */
#endif



#if defined( __QNXNTO__ )
  // compiling for QNX Neutrino
  // don't know if we must make differences for different compilers
  
  #include <hw/inout.h>
    
  // ATTENTION: mmap_device_io() must be called and the 
  // result be used to acces the ports.  
  // Currently, a segmentation fault will occur if the port I/O 
  // functions are being called.
  
  #define inp( _p )        in8( (_p) )
  #define inpw( _p )       in16( (_p) )
  #define inpd( _p )       in32( (_p) )

  #define outp( _p, _v )   out8( (_p), (_v) )
  #define outpw( _p, _v )  out16( (_p), (_v) )
  #define outpd( _p, _v )  out32( (_p), (_v) )

#else
  // compiling for QNX 4

  #if defined( __WATCOMC__ )
    // using Watcom C
    // Include prototypes of port I/O functions 
    // which should match the calls used in the mbglib functions.

    #include <conio.h>         

  #endif

#endif


#endif  /* _MBG_QNX_H */

